<template>
<a-spin :spinning="confirmLoading">
    <j-form-container :disabled="formDisabled">
        <a-form-model ref="form" :model="model" :rules="validatorRules" slot="detail">
            <a-row>
                <a-col :span="24">
                    <a-form-model-item label="加料名称" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="name">
                        <a-input v-model="model.name" placeholder="请输入加料名称"></a-input>
                    </a-form-model-item>
                </a-col>
                <a-col :span="24">
                    <a-form-model-item label="加料金额" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="money">
                        <a-input-number v-model="model.money" placeholder="请输入加料金额" style="width: 100%" />
                    </a-form-model-item>
                </a-col>
                <!-- <a-col :span="24">
                    <a-form-model-item label="备注" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="">
                        <a-input v-model="model.remark" placeholder="请输入备注"></a-input>
                    </a-form-model-item>
                </a-col> -->

                <a-col :span="24">
                    <a-form-model-item label="是否启用" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="state">
                        <a-switch v-model="model.state" checked-children="启用" un-checked-children="禁用" />
                    </a-form-model-item>
                </a-col>

                <!-- <a-col :span="24">
                    <a-form-model-item label="应用范围" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="type">
                        <a-radio-group :options="options" v-model="model.type" @change="onChange" />
                    </a-form-model-item>
                </a-col> -->
            </a-row>
        </a-form-model>
    </j-form-container>
</a-spin>
</template>

<script>
import {
    httpAction,
    getAction
} from "@/api/manage";
import {
    validateDuplicateValue
} from "@/utils/util";

export default {
    name: "PosTableForm",
    components: {},
    props: {
        //表单禁用
        disabled: {
            type: Boolean,
            default: false,
            required: false,
        },
    },
    data() {
        return {
            options: [{
                    label: '全部菜品',
                    value: 0
                },
                {
                    label: '菜品分类',
                    value: 1
                },
                {
                    label: '菜品',
                    value: 2
                },
            ],
            value: 1,
            model: {
                state:false,
                type:0,
                // detailList:[],
                // remark:"",
                // id:''
            },
            labelCol: {
                xs: {
                    span: 24
                },
                sm: {
                    span: 5
                },
            },
            wrapperCol: {
                xs: {
                    span: 24
                },
                sm: {
                    span: 16
                },
            },
            confirmLoading: false,
            validatorRules: {
                name: [{
                    required: true,
                    message: "请输入口味名称!"
                }],
                money: [{
                    required: true,
                    message: "请输入金额!"
                }],
                state: [{
                    required: true,
                    message: "请选择是否开启!"
                }],
                type: [{
                    required: true,
                    message: "请选择应用范围!"
                }],
            },
            url: {
                add: "/pos/posJialiaoConfig/add",
                edit: "/pos/posJialiaoConfig/edit",
                queryById: "/pos/posTable/queryById",
            },
            posTypeList: [],
            tableTypeList: [],
            regionList: []
        };
    },
    computed: {
        formDisabled() {
            return this.disabled;
        },
    },
    created() {
        var _info = JSON.parse(localStorage.getItem("storeInfo"));
        if (_info) {
            this.model.hotelId = _info.id;
        }
        //备份model原始值
        this.modelDefault = JSON.parse(JSON.stringify(this.model));
        getAction("/pos/posType/list", {
            hotelId: _info.id,
            pageNo: 1,
            pageSize: 100,
        }).then((res) => {
            if (res.success) {
                this.posTypeList = res.result.records;
            }
        });
        getAction("/pos/posTableType/list", {
            hotelId: _info.id,
            pageNo: 1,
            pageSize: 100,
        }).then((res) => {
            if (res.success) {
                this.tableTypeList = res.result.records;
            }
        });
        getAction("/pos/posRegion/list", {
            hotelId: _info.id,
            pageNo: 1,
            pageSize: 100,
        }).then((res) => {
            if (res.success) {
                this.regionList = res.result.records;
            }
        });
    },
    methods: {
        onChange(e){
            console.log(e);
        },
        add() {
            this.edit(this.modelDefault);
        },
        edit(record) {
            console.log(record);
            this.model = Object.assign({}, record);
            this.visible = true;
        },
        submitForm() {
            const that = this;
            // 触发表单验证
            this.$refs.form.validate((valid) => {
                if (valid) {
                    that.confirmLoading = true;
                    let httpurl = "";
                    let method = "";
                    if (!this.model.id) {
                        httpurl += this.url.add;
                        method = "post";
                    } else {
                        httpurl += this.url.edit;
                        method = "put";
                    }
                    // this.model.state = this.model.status ? 1 : 0;
                    this.model.money = parseInt(this.model.money)
                    console.log(this.model);
                    httpAction(httpurl, this.model, method)
                        .then((res) => {
                            if (res.success) {
                                that.$message.success(res.message);
                                that.$emit("ok");
                            } else {
                                that.$message.warning(res.message);
                            }
                        })
                        .finally(() => {
                            that.confirmLoading = false;
                        });
                }
            });
        },
    },
};
</script>
